#include <iostream>
#include <vector>
#include <cmath>
using namespace std;

int convert(int num, int base){
  int result = 0;
  //first, find the largest power of base <= num.  Yes, you can probably do this with logs
  int pos = 0;
  while(pow(base,pos) < num)
    pos++;
  int place = pow(base,pos);
  while(place >0){
    int new_digit = num/place;
    if(new_digit >9)
      return -1;
    result = 10*result + new_digit;
    num = num%place;
    place = place / base;
  }
  return result;
}

int main(){
  int cur_case = 1;
  int n,m;
  cin >> n >> m;
  while(n > 0){
    int b = 2;
    bool found = false;
    while(b <= 10000 && ! found){
      int new_m = convert(n,b);
      if(m == new_m)
	found = true;
      else
	b++;
    }
    if(found){
      cout << "Case " << cur_case << ": " << b << endl;
    }
    else
      cout << "Case " << cur_case << ": Not possible" << endl;
    cur_case++;
    cin >> n >> m;
  }
  return 0;
}

      
