#include <iostream>
#include <string>

using namespace std;

string Decrypt(const string& pad, const string& code){
  string result = code;
  for(int i = 0; i < code.size(); i++){
    int diff = pad[i] - 'A';
    result[i] = result[i] - diff;
    if(result[i] < 'A')
      result[i] = result[i] + 26;

  }
  return result;
}

int main(){
 
  int n;
  cin >> n;
  int cur_case = 1;
  while(n > 0){
    string pad1;
    string pad2;
    string code;
    string plaintext;
  
    cin >> pad1;
    cin >> pad2;
    cin >> code;
   
    
    string diff = code;
    
    string plain1 = Decrypt(pad1, code);
    //   cout << "Plaintext1: " << plain1 << endl;
    string plain2 = Decrypt(pad2, code);
    //   cout << "Plaintext2: " << plain2 << endl;
    int m;
    cin >> m;
    cin >> plaintext;
    if(plain1.find(plaintext) != string::npos && plain2.find(plaintext) != string::npos)
      cout << "Case " << cur_case << ": Both" << endl;
    else{
      if(plain1.find(plaintext) != string::npos)
	cout << "Case " << cur_case << ": Pad 1" << endl;
      else if(plain2.find(plaintext) != string::npos)
	cout << "Case " << cur_case << ": Pad 2" << endl;
      else
	cout << "Case " << cur_case << ": Neither" << endl;
    }
    cin >> n;
    cur_case++;
  }
  return 0;
}
